/*----------------------------------------------------------------*/
/*								  */
/*  Example of sqldsc() : Describe Item of Select		  */
/*								  */
/*----------------------------------------------------------------*/

#include "stdio.h"
#include "sql.h"
#include "errsql.h"

/* error defines */
#define APIERROR    1

#define apierr(a) error(a,__LINE__, APIERROR)

	  SQLTCUR   cur = 0;		/* SQLBASE cursor number	    */
	  SQLTRCD   rcd = 0;		/* SQLBASE return code		    */

main()
{
	  SQLTNSI   nsi;		/* number of select items	    */
	  SQLTSLC   i;			/* column number to be described    */
	  SQLTDDT   edt;		/* external data type		    */
	  SQLTDDL   edl;		/* external data length 	    */
	  char	    buf[15];		/* buffer for format print date     */
	  SQLTCHL   chl;		/* column header length 	    */
	  SQLTPRE   prec;		/* precision			    */
	  SQLTSCA   scale;		/* scale			    */

static	  char	    dbnam[] = "demox";
static char ctbcom[] = "CREATE TABLE TEST (AINT INT, ASMALLINT SMALLINT,\
AFLOAT FLOAT, ACHAR9 CHAR(9), AVARCHAR8 CHAR(8), ALONGVARCHAR LONG VARCHAR,\
ADECIMAL62 DECIMAL(6,2), ADATE DATE, ATIME TIME, ATIMESTAMP TIMESTAMP)";
static char selcom[] = "SELECT * FROM TEST";

  /* CONNECT TO THE DATABASE */

  if (rcd = sqlcnc(&cur, dbnam, 0))
          apierr("SQLCNC");

  /* CREATE THE TABLE */

  if (rcd = sqlcex(cur, ctbcom, 0))
	  apierr("SQLCEX");

  /* COMPILE THE SELECT COMMAND */

  if (rcd = sqlcom(cur, selcom, 0))
	  apierr("SQLCOM");

  if (rcd = sqlnsi(cur,&nsi))
	  apierr("SQLNSI");

  /* DESCRIBE */

  for (i = 1; i <= nsi; i++)
  {
    memset(buf, '\0', sizeof(buf));	/* fill the buffer with nulls	    */
    if (rcd = sqldsc(cur,i,&edt,&edl,buf,&chl,&prec,&scale))
	    apierr("SQLDSC");
    printf("i=%d, edt=%d, edl=%d, colname=%s, chl=%d, prec=%d, scale=%d\n",
	    i,edt,edl,buf,chl,prec,scale);
  }

  if (rcd = sqldis(cur))
	  apierr("SQLDIS");
  
}

/*
  ERROR - prints an error message for the utility
*/
	  error(what, line, type)
	  char*     what;		/* description of what happened     */
	  int	    line;		/* line number where error occured  */
	  int	    type;		/* type of error		    */
  {
	  char	    msg[200];		/* error message buffer 	    */

      sqlerr(rcd, msg); 		  /* get the error message	    */
      printf("\nError: %s at line %d: %s, Error # %d\n", what, line, msg,rcd);
  }


